#!/usr/bin/perl
use strict; use warnings; use Getopt::Long;

# This is a script to do some one-time editing of the genome assembly.

#- INITIALIZE ---------------------------------------------------------------#

my $input = "../annotations/aedes_albopictus_LA_20200616.fa";
my $output = "../annotations/aedes_albopictus_LA_20200616.nixsplit.fa";
my $help;

GetOptions ('i:s'       => \$input,
            'o:s'       => \$output,
            'help|h'    => \$help);
if ($help) {die "
This is a one-time script.

  -i path to the input file.
  -o path to the output file.
  -h display this message.\n\n"}

open (my $in, '<', $input) or die "
Could not open the input file '$input'.\n";
open (my $out, '>', $output) or die "
Could not open the output file '$output'.\n";

#- BEGIN CODE ---------------------------------------------------------------#

while (<$in>) {
  unless ($_ =~ m/>chr3.129/) {
    print $out $_;
    next
  }
  print $out $_;
  my $sequence = <$in>;
  chomp $sequence;
  
  print $out substr($sequence, 0, 2255968);
  print $out "\n>Nix_scaffold\n";
  print $out substr($sequence, 2255968);
  print $out "\n"
}

#- TIDY UP ------------------------------------------------------------------#

close $in; close $out;

#- FIN ----------------------------------------------------------------------#