#-----------------------------------------------------------------------------#
# STEP 47: Make a new translation file                                        #
#-----------------------------------------------------------------------------#

# Need to rename the sequences in the genome.

#- INITIALIZE ----------------------------------------------------------------#

setwd('C:/Users/Jack/Documents/bsa/')
library(dplyr)
library(data.table)

# Where the old translation file is:
loc_old = "contig_info/position_translator.txt"
# Where the new one should go:
loc_new = "contig_info/position_translator_2.txt"

#- READ IN THE OLD -----------------------------------------------------------#

old = fread(loc_old)
new = old[,c("true_chromosome", "true_scaffold", "true_chromosome_position")]
new = cbind(new, new)
colnames(new) = c("old_chromosome", "old_scaffold", "old_chromosome_position",
                  "new_chromosome", "new_scaffold", "new_chromosome_position")

#- ADJUST CHROMOSOME POSITIONS ON CHROMOSOME 3 TO ACCOUNT FOR MISSING CHUNK --#

new$new_chromosome_position[new$old_chromosome == 3 &
                            new$old_scaffold > 130] = 
  -1626558 + new$new_chromosome_position[new$old_chromosome == 3 &
                                         new$old_scaffold > 130]

#- ADJUST SCAFFOLD NUMBERS ON CHROMOSOME 1 TO ACCOUNT FOR ADDED SCAFFOLD -----#

new$new_scaffold[new$old_chromosome == 1 &
                 new$old_scaffold > 85] =
  1 + new$new_scaffold[new$old_chromosome == 1 &
                       new$old_scaffold > 85]

#- ALSO ADJUST CHROMOSOME POSITIONS ------------------------------------------#

new$new_chromosome_position[new$old_chromosome == 1 &
                            new$old_scaffold > 85] =
  1626558 + new$new_chromosome_position[new$old_chromosome == 1 &
                                        new$old_scaffold > 85]

#- ADD ENTRY FOR THE NEW SCAFFOLD --------------------------------------------#

new_line = data.frame("Nix_scaffold", "Nix", 0, 1, 86, -1)
colnames(new_line) = colnames(new)

new = rbind(new, new_line)
new$new_chromosome_position[new$old_chromosome == "Nix_scaffold"] =
  new$old_chromosome_position[new$old_chromosome == 1 &
                              new$old_scaffold == 86]

#- WRITE THE NEW TRANSLATOR FILE ---------------------------------------------#

new$old_name = paste0("chr", new$old_chromosome, ".", new$old_scaffold)
new$old_name[new$old_chromosome == "Nix_scaffold"] = "Nix_scaffold"
new$is_reversed = 0
write.table(new, file=loc_new, row.names=F, col.names=T, sep="\t", quote=F)

#- FIN -----------------------------------------------------------------------#